Index: configure.ac
===================================================================
--- configure.ac	(revision 13010)
+++ configure.ac	(working copy)
@@ -403,7 +403,14 @@
 AC_SUBST(FLUID)
 
 AC_ARG_ENABLE(threads, [  --enable-threads        enable multi-threading support [[default=yes]]])
+NEW_PREFIX_SYMBOL_FLAG="-DFLTK_USE_NEW_PREFIX_SYMBOL=-1"
 
+AC_ARG_ENABLE(newprefix, [  --enable-newprefix      enable use of new prefix symbol 0x0F [[default=no]]])
+if test x$enable_newprefix = xyes; then
+  NEW_PREFIX_SYMBOL_FLAG="-DFLTK_USE_NEW_PREFIX_SYMBOL=1"
+fi
+AC_SUBST(NEW_PREFIX_SYMBOL_FLAG)
+
 AC_ARG_WITH(optim, [  --with-optim="flags"    use custom optimization flags])
 
 AC_ARG_WITH(archflags, [  --with-archflags="flags"
Index: examples/wizard-simple.cxx
===================================================================
--- examples/wizard-simple.cxx	(revision 13010)
+++ examples/wizard-simple.cxx	(working copy)
@@ -41,7 +41,7 @@
     // Wizard: page 1
     {
         Fl_Group *g = new Fl_Group(0,0,400,300);
-        Fl_Button *next = new Fl_Button(290,265,100,25,"Next @->"); next->callback(next_cb);
+        Fl_Button *next = new Fl_Button(290,265,100,25,"Next " FL_RT_ARROW_TX); next->callback(next_cb);
         Fl_Multiline_Output *out = new Fl_Multiline_Output(10,30,400-20,300-80,"Welcome");
         out->labelsize(20);
         out->align(FL_ALIGN_TOP|FL_ALIGN_LEFT);
@@ -51,8 +51,8 @@
     // Wizard: page 2
     {
         Fl_Group *g = new Fl_Group(0,0,400,300);
-        Fl_Button *next = new Fl_Button(290,265,100,25,"Next @->"); next->callback(next_cb);
-        Fl_Button *back = new Fl_Button(180,265,100,25,"@<- Back"); back->callback(back_cb);
+        Fl_Button *next = new Fl_Button(290,265,100,25,"Next " FL_RT_ARROW_TX); next->callback(next_cb);
+        Fl_Button *back = new Fl_Button(180,265,100,25,FL_LT_ARROW_TX " Back"); back->callback(back_cb);
         Fl_Multiline_Output *out = new Fl_Multiline_Output(10,30,400-20,300-80,"Terms And Conditions");
         out->labelsize(20);
         out->align(FL_ALIGN_TOP|FL_ALIGN_LEFT);
@@ -63,7 +63,7 @@
     {
         Fl_Group *g = new Fl_Group(0,0,400,300);
         Fl_Button *done = new Fl_Button(290,265,100,25,"Finish"); done->callback(done_cb);
-        Fl_Button *back = new Fl_Button(180,265,100,25,"@<- Back"); back->callback(back_cb);
+        Fl_Button *back = new Fl_Button(180,265,100,25, FL_LT_ARROW_TX " Back"); back->callback(back_cb);
         Fl_Multiline_Output *out = new Fl_Multiline_Output(10,30,400-20,300-80,"Finish");
         out->labelsize(20);
         out->align(FL_ALIGN_TOP|FL_ALIGN_LEFT);
Index: FL/Enumerations.H
===================================================================
--- FL/Enumerations.H	(revision 13010)
+++ FL/Enumerations.H	(working copy)
@@ -417,7 +417,7 @@
  */
 enum Fl_When { // Fl_Widget::when():
   FL_WHEN_NEVER		= 0,	///< Never call the callback
-  FL_WHEN_CHANGED	= 1,	///< Do the callback only when the widget value changes
+  FL_WHEN_CHANGED	= 1,	///< Do the callback only when the widget value changes (or checkbox changes)
   FL_WHEN_NOT_CHANGED	= 2,	///< Do the callback whenever the user interacts with the widget
   FL_WHEN_RELEASE	= 4,	///< Do the callback when the button or key is released and the value changes
   FL_WHEN_RELEASE_ALWAYS= 6,	///< Do the callback when the button or key is released, even if the value doesn't change
@@ -1225,8 +1225,66 @@
 #    define inactive	fl_inactive
 #  endif // FLTK_1_0_COMPAT
 
+
+#if (FLTK_USE_NEW_PREFIX_SYMBOL==1)
+
+  #define FL_SYMBOL_CHAR '\x0F'
+  #define FL_SYMBOL_TX "\x0F"
+
+  #define FL_UP_TRIANGLE_TX "\x0F8>"
+  #define FL_DN_TRIANGLE_TX "\x0F2>"
+
+  #define FL_UP_ARROW_TX "\x0F-42<"
+  #define FL_DN_ARROW_TX "\x0F-42>"
+  #define FL_LT_ARROW_TX "\x0F<-"
+  #define FL_RT_ARROW_TX "\x0F->"
+  #define FL_SYM_FILEOPEN_TX "\x0Ffileopen"
+  #define FL_SYM_CROSS_TX "\x0F-3refresh"
+  #define FL_SYM_SEARCH_TX "\x0Fsearch"
+
+  #define FL_FLUID_LF_ALIGN_TX "\x0F-1<-"
+  #define FL_FLUID_RT_ALIGN_TX "\x0F-1->"
+  #define FL_FLUID_TOP_ALIGN_TX "\x0F-18"
+  #define FL_FLUID_BOT_ALIGN_TX "\x0F-12"
+  #define FL_FLUID_INSIDE_ALIGN_TX "\x0F-3square"
+
+  #define FL_COUNTER_LF2_TX "\x0F-4<<"
+  #define FL_COUNTER_LF_TX "\x0F-4<"
+  #define FL_COUNTER_RT2_TX "\x0F-4>>"
+  #define FL_COUNTER_RT_TX "\x0F-4>"
+
+#elif (FLTK_USE_NEW_PREFIX_SYMBOL==-1)
+  #define FL_SYMBOL_CHAR '@'
+  #define FL_SYMBOL_TX "@"
+
+  #define FL_UP_TRIANGLE_TX "@8>"
+  #define FL_DN_TRIANGLE_TX "@2>"
+
+  #define FL_UP_ARROW_TX "@-42<"
+  #define FL_DN_ARROW_TX "@-42>"
+  #define FL_LT_ARROW_TX "@<-"
+  #define FL_RT_ARROW_TX "@->"
+  #define FL_SYM_FILEOPEN_TX "@fileopen"
+  #define FL_SYM_CROSS_TX "@-3refresh"
+  #define FL_SYM_SEARCH_TX "@search"
+
+  #define FL_FLUID_LF_ALIGN_TX "@-1<-"
+  #define FL_FLUID_RT_ALIGN_TX "@-1->"
+  #define FL_FLUID_TOP_ALIGN_TX "@-18"
+  #define FL_FLUID_BOT_ALIGN_TX "@-12"
+  #define FL_FLUID_INSIDE_ALIGN_TX "@-3square"
+
+  #define FL_COUNTER_LF2_TX "@-4<<"
+  #define FL_COUNTER_LF_TX "@-4<"
+  #define FL_COUNTER_RT2_TX "@-4>>"
+  #define FL_COUNTER_RT_TX "@-4>"
+#else
+  #error "FLTK_USE_NEW_PREFIX_SYMBOL not set - use 'make clean' for build of FLTK or 'fflk-config --cxxflags' for applications"
 #endif
 
+
+#endif
+
 //
 // End of "$Id$".
 //
Index: FL/Fl.H
===================================================================
--- FL/Fl.H	(revision 13010)
+++ FL/Fl.H	(working copy)
@@ -208,6 +208,17 @@
   static void damage(int d) {damage_ = d;}
   
 public:
+
+  // define symbol character for third party library builders who want
+  // to provide a single library and support builds using old @ symbol
+  // prefix or new 0x0F symbol prefix.
+  static const char symbol_prefix_char;
+
+  // variable to determine if new method used to handle shortcuts should
+  // be used.
+  static bool new_shortcut_logic;
+
+
   /** Enumerator for global FLTK options.
       These options can be set system wide, per user, or for the running
       application only.
@@ -252,6 +263,9 @@
      /// if the GTK library is available on the platform (linux/unix only).
      /// When switched off, GTK file dialogs aren't used even if the GTK library is available.
     OPTION_FNFC_USES_GTK,
+      /// Make a copy of the labels provided to Fl_Widget instead of
+      /// using the pointer passed to it.
+    OPTION_COPY_LABELS,
       // don't change this, leave it always as the last element
       /// For internal use only.
     OPTION_LAST
@@ -1096,6 +1110,10 @@
   /** Sets the functions to call to draw and measure a specific labeltype. */
   static void set_labeltype(Fl_Labeltype, Fl_Labeltype from); // is it defined ?
 
+  // labels:
+  static void copy_labels(int v) { option(OPTION_COPY_LABELS, (v!=0)); };
+  static int  copy_labels() { return option(OPTION_COPY_LABELS); };
+
   // boxtypes:
   static Fl_Box_Draw_F *get_boxtype(Fl_Boxtype);
   static void set_boxtype(Fl_Boxtype, Fl_Box_Draw_F*,uchar,uchar,uchar,uchar);
Index: FL/fl_ask.H
===================================================================
--- FL/fl_ask.H	(revision 13010)
+++ FL/fl_ask.H	(working copy)
@@ -56,7 +56,12 @@
 FL_EXPORT int fl_choice(const char *q,const char *b0,const char *b1,const char *b2,...) __fl_attr((__format__ (__printf__, 1, 5)));
 FL_EXPORT const char *fl_input(const char *label, const char *deflt = 0, ...) __fl_attr((__format__ (__printf__, 1, 3)));
 FL_EXPORT const char *fl_password(const char *label, const char *deflt = 0, ...) __fl_attr((__format__ (__printf__, 1, 3)));
+FL_EXPORT const char *fl_input_n(const char *label, int maxinput, const char *deflt = 0, ...) __fl_attr((__format__ (__printf__, 1, 4)));
+FL_EXPORT const char *fl_password_n(const char *label, int maxinput, const char *deflt = 0, ...) __fl_attr((__format__ (__printf__, 1, 4)));
 
+// set the icon character for fl_choice - set to 0 for default
+FL_EXPORT void fl_choice_icon(char iconchar);
+
 FL_EXPORT Fl_Widget *fl_message_icon();
 extern FL_EXPORT Fl_Font fl_message_font_;
 extern FL_EXPORT Fl_Fontsize fl_message_size_;
Index: FL/Fl_Browser.H
===================================================================
--- FL/Fl_Browser.H	(revision 13010)
+++ FL/Fl_Browser.H	(working copy)
@@ -29,8 +29,6 @@
 #include "Fl_Browser_.H"
 #include "Fl_Image.H"
 
-struct FL_BLINE;
-
 /**
   The Fl_Browser widget displays a scrolling list of text
   lines, and manages all the storage for the text.  This is not a text
@@ -78,7 +76,21 @@
   For more info, see find_item(int).
 */
 class FL_EXPORT Fl_Browser : public Fl_Browser_ {
+protected:
 
+  struct FL_BLINE { // data is in a linked list of these
+    FL_BLINE* prev;
+    FL_BLINE* next;
+    void* data;
+    Fl_Image* icon;
+    int width;      // width for updating width fast
+    short length;		// sizeof(txt)-1, may be longer than string
+    char flags;		// selected, displayed
+    char txt[1];		// start of allocated array
+  };
+
+private:
+
   FL_BLINE *first;		// the array of lines
   FL_BLINE *last;
   FL_BLINE *cache;
@@ -86,11 +98,15 @@
   int lines;                	// Number of lines
   int full_height_;
   const int* column_widths_;
-  char format_char_;		// alternative to @-sign
+  char format_char_;    // alternative to FL_SYMBOL_CHAR-sign
   char column_char_;		// alternative to tab
 
 protected:
+  static const int SELECTED =     1;
+  static const int NOTDISPLAYED = 2;
+  static const int CHECKED =      4;
 
+
   // required routines for Fl_Browser_ subclass:
   void* item_first() const ;
   void* item_next(void* item) const ;
@@ -100,6 +116,7 @@
   void item_select(void* item, int val);
   int item_height(void* item) const ;
   int item_width(void* item) const ;
+  int item_quick_width(void *item) const;
   void item_draw(void* item, int X, int Y, int W, int H) const ;
   int full_height() const ;
   int incr_height() const ;
@@ -207,9 +224,10 @@
   ~Fl_Browser() { clear(); }
 
   /**
-    Gets the current format code prefix character, which by default is '\@'.
+    Gets the current format code prefix character, which by default is FL_SYMBOL_CHAR.
     A string of formatting codes at the start of each column are stripped off
-    and used to modify how the rest of the line is printed:
+    and used to modify how the rest of the line is printed.  The samples below
+    assume the FL_SYMBOL_CHAR is '@':
     
     \li <tt>'\@.'</tt> Print rest of line, don't look for more '\@' signs
     \li <tt>'\@\@'</tt> Print rest of line starting with '\@'
@@ -238,8 +256,8 @@
   char format_char() const { return format_char_; }
   /**
     Sets the current format code prefix character to \p c.
-    The default prefix is '\@'.  Set the prefix to 0 to disable formatting.
-    \see format_char() for list of '\@' codes
+    The default prefix is FL_SYMBOL_CHAR.  Set the prefix to 0 to disable formatting.
+    \see format_char() for list of FL_SYMBOL_CHAR codes
   */
   void format_char(char c) { format_char_ = c; }
   /**
Index: FL/Fl_Browser_.H
===================================================================
--- FL/Fl_Browser_.H	(revision 13010)
+++ FL/Fl_Browser_.H	(working copy)
@@ -34,6 +34,7 @@
 #define FL_SELECT_BROWSER	1	/**< type() of FL_Select_Browser */
 #define FL_HOLD_BROWSER		2	/**< type() of Fl_Hold_Browser */
 #define FL_MULTI_BROWSER	3	/**< type() of Fl_Multi_Browser */
+#define FL_CHECKBOX_BROWSER	4	/**< type() of Fl_Multi_Browser */
 
 #define FL_SORT_ASCENDING	0	/**< sort browser items in ascending alphabetic order. */
 #define FL_SORT_DESCENDING	1	/**< sort in descending order */
@@ -81,7 +82,6 @@
   int hposition_;	// where user wants it panned to
   int real_hposition_;	// the current horizontal scrolling position
   int offset_;		// how far down top_ item the real_position is
-  int max_width;	// widest object seen so far
   uchar has_scrollbar_;	// which scrollbars are enabled
   Fl_Font textfont_;
   Fl_Fontsize textsize_;
@@ -89,13 +89,26 @@
   void* top_;		// which item scrolling position is in
   void* selection_;	// which is selected (except for FL_MULTI_BROWSER)
   void *redraw1,*redraw2; // minimal update pointers
-  void* max_width_item;	// which item has max_width_
   int scrollbar_size_;	// size of scrollbar trough
+  int flags_ex_;  // extended flags for class
 
+  static const int FLAG_EX_SHORTCUT=1;           // support shortcuts on browser items
+  static const int FLAG_EX_FOCUS_COLOR_CHANGE=2; // change selection color based on focus
+  static const int FLAG_EX_CHECK_CHANGED=4;      // checkbox item check changed
+  static const int FLAG_EX_FULL_KB_SELECT=8;     // change selection bar on pgup/pgdn/home/end
+  static const int FLAG_EX_SHORTCUT_ALT=0x10;    // support alt keys to shortcuts on browser items
+
   void update_top();
 
 protected:
+  int max_width;	// widest object seen so far
+  void* max_width_item;	// which item has max_width_
+  void set_scrollbar_visiblity();
 
+  inline int check_size(void) const { return textsize()-2; };
+  inline int check_pre_gap(void) const { return 2; };
+  inline int check_post_gap(void) const { return 5; };
+
   // All of the following must be supplied by the subclass:
   /**
     This method must be provided by the subclass 
@@ -138,6 +151,7 @@
     \returns The width of the item in pixels.
   */
   virtual int item_width(void *item) const = 0;
+  virtual int item_quick_width(void *item) const;
   virtual int item_quick_height(void *item) const ;
   /**
     This method must be provided by the subclass to draw the \p item
@@ -220,6 +234,9 @@
   int select(void *item,int val=1,int docallbacks=0);
   int select_only(void *item,int docallbacks=0);
   int deselect(int docallbacks=0);
+
+  virtual void checked(void *item,int val);
+
   /**
     Gets the vertical scroll position of the list as a pixel position \p pos.
     The position returned is how many pixels of the list are scrolled off the top edge
@@ -380,8 +397,77 @@
   */
   void scrollbar_left() { scrollbar.align(FL_ALIGN_LEFT); }
   void sort(int flags=0);
+
+  /**
+    set/clear/check the checked status flag.  The internal handler
+    sets the check_changed() flag.  The application programmer
+    needs to clear_check_changed() if they want to monitor the
+    check_changed() flag.
+  */
+ protected:
+  void set_check_changed() { flags_ex_|=FLAG_EX_CHECK_CHANGED; };
+ public:
+  void clear_check_changed() { flags_ex_&=~FLAG_EX_CHECK_CHANGED; };
+  bool check_changed() const { return (flags_ex_ & FLAG_EX_CHECK_CHANGED)!=0; };
+
+  /**
+    enable/disable supporting shortcuts on browser items
+  */
+  void item_shortcuts(int on) 
+  { 
+    if (on)
+      flags_ex_|=FLAG_EX_SHORTCUT;
+    else
+      flags_ex_&=~FLAG_EX_SHORTCUT;
 };
+  bool item_shortcuts() const { return (flags_ex_ & FLAG_EX_SHORTCUT)!=0; };
 
+  /**
+    change the way shortcuts are handled.  enabling alt shortcuts causes
+    the shortcut to work when the browser doesn't have focus and alt-key
+    combination is used.  if alt shortcuts are not enabled then the short
+    cuts only work within the browser when it has focus.  alt-key allows
+    selection outside the browser group.  Note that this has no affect
+    unless shortcuts are enabled.
+  */
+  void alt_shortcuts(int on) 
+  { 
+    if (on) 
+      flags_ex_|=FLAG_EX_SHORTCUT_ALT; 
+    else
+      flags_ex_&=~FLAG_EX_SHORTCUT_ALT;
+  };
+  bool alt_shortcuts() const { return (flags_ex_ & FLAG_EX_SHORTCUT_ALT)!=0; };
+
+
+  /**
+    enable or disable changing color of the selection bar depending on if the
+    browser control has focus or not
+  */
+  void focus_color_change(int on) 
+  { 
+    if (on) 
+      flags_ex_|=FLAG_EX_FOCUS_COLOR_CHANGE;
+    else
+      flags_ex_&=~FLAG_EX_FOCUS_COLOR_CHANGE;
+  };
+  bool focus_color_change(void) const { return (flags_ex_ & FLAG_EX_FOCUS_COLOR_CHANGE)!=0; };
+
+ /**
+   enable or disable support for changing selection bar when keyboard
+   pgup/pgdn/home/end are used.
+  */
+  void full_kb_select(int on) 
+  { 
+    if (on) 
+      flags_ex_|=FLAG_EX_FULL_KB_SELECT;
+    else
+      flags_ex_&=~FLAG_EX_FULL_KB_SELECT;
+  };
+  bool full_kb_select() const { return (flags_ex_ & FLAG_EX_FULL_KB_SELECT)!=0; };
+
+};
+
 #endif
 
 //
Index: FL/Fl_Button.H
===================================================================
--- FL/Fl_Button.H	(revision 13010)
+++ FL/Fl_Button.H	(working copy)
@@ -76,11 +76,14 @@
 class FL_EXPORT Fl_Button : public Fl_Widget {
 
   int shortcut_;
+  int shortcut2_;
   char value_;
   char oldval;
   uchar down_box_;
+  char flags_ex_;
 
 protected:
+  static const int FLAG_EX_CLICK_ON_ENTER_KEY=1;  // cause normal button press when enter pressed
 
   static Fl_Widget_Tracker *key_release_tracker;
   static void key_release_timeout(void*);
@@ -120,6 +123,7 @@
     \retval int
    */
   int shortcut() const {return shortcut_;}
+  int shortcut2() const {return shortcut2_;}
 
   /**
     Sets the shortcut key to \c s.
@@ -141,6 +145,7 @@
     \param[in] s bitwise OR of key and shift flags
    */
   void shortcut(int s) {shortcut_ = s;}
+  void shortcut2(int s) {shortcut2_ = s;}
 
   /**
     Returns the current down box type, which is drawn when value() is non-zero.
@@ -167,8 +172,19 @@
 
   /// (for backwards compatibility)
   void down_color(unsigned c) {selection_color(c);}
+
+  /// option for enter to cause button click when a normal button has kb focus
+  void click_on_enter_key(int on) 
+  { 
+    if (on)
+      flags_ex_|=FLAG_EX_CLICK_ON_ENTER_KEY; 
+    else
+      flags_ex_&=~FLAG_EX_CLICK_ON_ENTER_KEY;
 };
+  bool click_on_enter_key() const { return (flags_ex_ & FLAG_EX_CLICK_ON_ENTER_KEY)!=0; };
 
+};
+
 #endif
 
 //
Index: FL/Fl_Checkbox_Browser.H
===================================================================
--- FL/Fl_Checkbox_Browser.H	(revision 0)
+++ FL/Fl_Checkbox_Browser.H	(working copy)
@@ -0,0 +1,76 @@
+//
+// "$Id: Fl_Checkbox_Browser.H 8736 2011-05-24 20:00:56Z AlbrechtS $"
+//
+// Checkbox browser header file for the Fast Light Tool Kit (FLTK).
+//
+// Copyright 1998-2011 by Bill Spitzak and others.
+//
+// This library is free software; you can redistribute it and/or
+// modify it under the terms of the GNU Library General Public
+// License as published by the Free Software Foundation; either
+// version 2 of the License, or (at your option) any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+// Library General Public License for more details.
+//
+// You should have received a copy of the GNU Library General Public
+// License along with this library; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+// USA.
+//
+// Please report all bugs and problems on the following page:
+//
+//     http://www.fltk.org/str.php
+//
+
+/* \file
+   Fl_Checkbox_Browser widget . */
+
+#ifndef Fl_Checkbox_Browser_H
+#define Fl_Checkbox_Browser_H
+
+#include "Fl_Browser.H"
+
+/**
+  The Fl_Checkbox_Browser is a subclass of Fl_Browser
+  which lets the user select a single item, or no items by clicking on
+  the empty space as well as check boxes on items.  As long as the mouse
+  button is held down the item pointed to by it is highlighted, and this
+  highlighting remains on when the mouse button is released. Normally the
+  callback is done when the user releases the mouse, but you can change
+  this with when().
+  <P>See Fl_Browser for methods to add and remove lines from the browser.
+*/
+class FL_EXPORT Fl_Checkbox_Browser : public Fl_Browser {
+  int nchecked_;
+
+public:
+  /**
+    Creates a new Fl_Checkbox_Browser widget using the given
+    position, size, and label string. The default boxtype is FL_DOWN_BOX.
+    The constructor specializes Fl_Browser() by setting the type to FL_CHECKBOX_BROWSER.
+    The destructor destroys the widget and frees all memory that has been allocated.
+ */
+  Fl_Checkbox_Browser(int X,int Y,int W,int H,const char *L=0);
+
+  int nchecked() const { return nchecked_; }
+  void checked(void *item,int val);
+
+  /** Gets the current status of item item. */
+  int checked(int i) const;
+  /** Sets the check status of item item to b. */
+  void checked(int i, int b);
+  /**  Sets all the items checked.*/
+  void check_all();
+  /**  Sets all the items unchecked.*/
+  void check_none();
+
+};
+
+#endif
+
+//
+// End of "$Id: Fl_Checkbox_Browser.H 8736 2011-05-24 20:00:56Z AlbrechtS $".
+//
Index: FL/fl_draw.H
===================================================================
--- FL/fl_draw.H	(revision 13010)
+++ FL/fl_draw.H	(working copy)
@@ -33,7 +33,9 @@
 
 // Label flags...
 FL_EXPORT extern char fl_draw_shortcut;
+FL_EXPORT extern char fl_force_wrap_breaks; // option set by app and/or widgets
 
+
 /** \addtogroup fl_attributes
     @{
 */
Index: FL/Fl_Help_Dialog.H
===================================================================
--- FL/Fl_Help_Dialog.H	(revision 13010)
+++ FL/Fl_Help_Dialog.H	(working copy)
@@ -82,6 +82,9 @@
   int w();
   int x();
   int y();
+	void set_modal(void) {
+		window_->set_modal();
+	}
 };
 #endif
 
Index: FL/Fl_Input_.H
===================================================================
--- FL/Fl_Input_.H	(revision 13010)
+++ FL/Fl_Input_.H	(working copy)
@@ -171,6 +171,15 @@
 
 protected:
 
+  /* extended flags for class */
+  static const int FLAG_EX_UNICODE_CHAR_INPUT=1;        // allow input of unicode char
+  static const int FLAG_EX_UNICODE_CHAR_BYTE=2;        // use single byte if available
+  static const int FLAG_EX_UNICODE_CHAR_ACTIVE=0x1000;  // in unicode input char mode
+  int flags_ex_;
+
+  /* work variable for building unicode char value */
+  unsigned int unicodeval_;
+
   /* Find the start of a word. */
   int word_start(int i) const;
 
@@ -208,6 +217,25 @@
   /* Return the number of lines displayed on a single page.  */
   int linesPerPage();
 
+  /* handle unicode input mode */
+  void unicode_input_active(int on)
+  {
+    if (on) {
+      if ((flags_ex_ & FLAG_EX_UNICODE_CHAR_ACTIVE)==0) {
+        flags_ex_ |= FLAG_EX_UNICODE_CHAR_ACTIVE;
+        minimal_update(position()); // cause cursor update
+      }
+    }
+    else if (flags_ex_ & FLAG_EX_UNICODE_CHAR_ACTIVE) {
+      flags_ex_ &= ~FLAG_EX_UNICODE_CHAR_ACTIVE;
+      minimal_update(position()); // cause cursor update
+    }
+  }
+  bool unicode_input_active(void) { return  (flags_ex_ & FLAG_EX_UNICODE_CHAR_ACTIVE)!=0; };
+
+  /* Helper for setting position */
+  int position_adjust(int p, int current_position);
+
 public:
 
   /* Change the size of the widget. */
@@ -490,6 +518,37 @@
   int tab_nav() const {
     return tab_nav_;
   }
+
+  /**
+    Enable or Disable support for entering unicode characters
+  */
+  void unicode_input(int on)
+  {
+    if (on)
+      flags_ex_ |= FLAG_EX_UNICODE_CHAR_INPUT;
+    else {
+      flags_ex_ &= ~FLAG_EX_UNICODE_CHAR_INPUT;
+      unicode_input_active(0);
+    }
+  }
+
+  bool unicode_input() { return (flags_ex_ & FLAG_EX_UNICODE_CHAR_INPUT)!=0; };
+
+  /**
+    Enable or Disable option for entering unicode characters.
+
+    Note that if this is enabled on any input field, other input fields can
+    have the value copy/paste to it as a single byte as well.
+  */
+  void unicode_single_byte(int on)
+  {
+    if (on)
+      flags_ex_ |= FLAG_EX_UNICODE_CHAR_BYTE;
+    else
+      flags_ex_ &= ~FLAG_EX_UNICODE_CHAR_BYTE;
+  }
+  bool unicode_single_byte() { return (flags_ex_ & FLAG_EX_UNICODE_CHAR_BYTE)!=0; };
+
 };
 
 #endif 
Index: FL/Fl_Input_Choice.H
===================================================================
--- FL/Fl_Input_Choice.H	(revision 13010)
+++ FL/Fl_Input_Choice.H	(working copy)
@@ -24,6 +24,8 @@
 /* \file
    Fl_Input_Choice widget . */
 
+
+
 #ifndef Fl_Input_Choice_H
 #define Fl_Input_Choice_H
 
@@ -54,11 +56,51 @@
   // Private class to handle slightly 'special' behavior of menu button
   class InputMenuButton : public Fl_Menu_Button {
     void draw();
+
+  protected:
+    static const int FLAG_EX_ARROW_SHORTCUT=1;  // allow arrow down to open menu
+    int flags_ex_;
+
   public:
     InputMenuButton(int X, int Y, int W, int H, const char *L=0);
+    int handle(int event);
+
+    void arrow_shortcut(int on) 
+    { 
+      if (on) {
+        flags_ex_ |= FLAG_EX_ARROW_SHORTCUT; 
+      }
+      else {
+        flags_ex_ &= ~FLAG_EX_ARROW_SHORTCUT;
+      }
   };
+    bool arrow_shortcut(void) const { return (flags_ex_ & FLAG_EX_ARROW_SHORTCUT)!=0; };
+  };
 
-  Fl_Input *inp_;
+
+  // This class works like Fl_Input but ignores FL_Up and FL_Down key
+  // presses so they are handled by its parent, the Fl_Input_Choice widget.
+  class FL_EXPORT InputSubclass : public Fl_Input {
+  protected:
+    static const int FLAG_EX_ARROW_SHORTCUT=1;  // allow arrow down to open menu
+    int flags_ex_;
+  public:
+    InputSubclass(int X, int Y, int W, int H);
+    int handle(int event);		// implemented in src/Fl_InputChoice.cxx
+
+    void arrow_shortcut(int on) 
+    { 
+      if (on) {
+        flags_ex_ |= FLAG_EX_ARROW_SHORTCUT; 
+      }
+      else {
+        flags_ex_ &= ~FLAG_EX_ARROW_SHORTCUT;
+      }
+    };
+    bool arrow_shortcut(void) const { return (flags_ex_ & FLAG_EX_ARROW_SHORTCUT)!=0; };
+  };
+
+  InputSubclass *inp_;
   InputMenuButton *menu_;
 
   // note: this is used by the Fl_Input_Choice ctor.
@@ -84,6 +126,8 @@
 
   void resize(int X, int Y, int W, int H);
 
+  int handle(int event);
+
   /** Adds an item to the menu.
     When any item is selected, the Fl_Input_Choice callback() is invoked,
     which can do something with the selected item.
@@ -181,8 +225,31 @@
     This can be used to directly access all of the Fl_Input widget's methods.
   */
   Fl_Input *input() { return inp_; }
+  /**
+    sets the maximum input size
+  */
+  void maximum_size(int size)
+  {
+    if (inp_)
+      inp_->maximum_size(size);
 };
 
+  void enable_arrow_shortcut(void) 
+  { 
+    menu_->arrow_shortcut(1); 
+    inp_->arrow_shortcut(1);
+  };
+  
+  void disable_arrow_shortcut(void) 
+  { 
+    inp_->arrow_shortcut(0);
+     menu_->arrow_shortcut(0); 
+  };
+
+  bool arrow_shortcut(void) const { return menu_->arrow_shortcut(); };
+
+};
+
 #endif // !Fl_Input_Choice_H
 
 //
Index: FL/Fl_Menu_Item.H
===================================================================
--- FL/Fl_Menu_Item.H	(revision 13010)
+++ FL/Fl_Menu_Item.H	(working copy)
@@ -35,7 +35,8 @@
   FL_SUBMENU_POINTER = 0x20,	///< Indicates user_data() is a pointer to another menu array
   FL_SUBMENU = 0x40,		///< This item is a submenu to other items
   FL_MENU_DIVIDER = 0x80,	///< Creates divider line below this item. Also ends a group of radio buttons.
-  FL_MENU_HORIZONTAL = 0x100	///< ??? -- reserved
+  FL_MENU_HORIZONTAL = 0x100,	///< ??? -- reserved
+  FL_MENU_NO_SPLIT = 0x200, /// don't create submenus when a slash is found
 };
 
 extern FL_EXPORT Fl_Shortcut fl_old_shortcut(const char*);
Index: FL/Fl_Spinner.H
===================================================================
--- FL/Fl_Spinner.H	(revision 13010)
+++ FL/Fl_Spinner.H	(working copy)
@@ -44,7 +44,10 @@
   double	step_;			// Amount to add/subtract for up/down
   const char	*format_;		// Format string for input field
   int		wrap_;			// wrap around at bounds (1/0)
+  int flags_ex_;      // additional option flags
 
+  static const int FLAG_EX_BLANK_ALLOWED=1;   // allow blank (zero) (outside of range)
+
 private:
 
   static void sb_cb(Fl_Widget *w, Fl_Spinner *sb); // internal callback
@@ -194,7 +197,19 @@
     Returns the selection color of the spinner widget's input field.
   */
   Fl_Color selection_color() const { return input_.selection_color(); }
+
+  /**
+   enable or disable support for making spinner values optional
+  */
+  void blank_allowed(int on) 
+  { 
+    if (on) 
+      flags_ex_|=FLAG_EX_BLANK_ALLOWED; 
+    else
+      flags_ex_&=~FLAG_EX_BLANK_ALLOWED;
 };
+  bool blank_allowed() { return (flags_ex_ & FLAG_EX_BLANK_ALLOWED)!=0; };
+};
 
 #endif // !Fl_Spinner_H
 
Index: FL/fl_utf8.h
===================================================================
--- FL/fl_utf8.h	(revision 13010)
+++ FL/fl_utf8.h	(working copy)
@@ -53,6 +53,18 @@
  */
 FL_EXPORT int fl_utf8bytes(unsigned ucs);
 
+/* returns the byte length of the UTF-8 char sequence (returns -1 if not valid) */
+FL_EXPORT int fl_utf8len_real(const char *str, int chars_avail);
+
+FL_EXPORT const char *fl_utf8_find_leading_char(const char *u8c, const char *u8s_start, int chars_avail);
+
+/* determine if char is potential continuation character */
+#define fl_utf8_is_continuation_char(ch) ((((unsigned char)(ch)) & 0xC0)==0x80)
+
+/* determine if looks like utf8 leading sequence character */
+#define fl_utf8_is_leading_char(ch) ((((unsigned char)(ch)) & 0xC0)==0xC0)
+
+
 /* OD: returns the byte length of the first UTF-8 char sequence (returns -1 if not valid) */
 FL_EXPORT int fl_utf8len(char c);
 
Index: fltk-config.in
===================================================================
--- fltk-config.in	(revision 13010)
+++ fltk-config.in	(working copy)
@@ -44,8 +44,8 @@
 
 # flags for C++ compiler:
 ARCHFLAGS="@ARCHFLAGS@"
-CFLAGS="@CFLAGS@ @LARGEFILE@ @PTHREAD_FLAGS@"
-CXXFLAGS="@CXXFLAGS@ @LARGEFILE@ @PTHREAD_FLAGS@"
+CFLAGS="@CFLAGS@ @NEW_PREFIX_SYMBOL_FLAG@ @LARGEFILE@ @PTHREAD_FLAGS@"
+CXXFLAGS="@CXXFLAGS@ @NEW_PREFIX_SYMBOL_FLAG@ @LARGEFILE@ @PTHREAD_FLAGS@"
 LDFLAGS="@LDFLAGS@"
 LDLIBS="@LIBS@"
 OPTIM="@OPTIM@"
Index: fluid/Fl_Type.cxx
===================================================================
--- fluid/Fl_Type.cxx	(revision 13010)
+++ fluid/Fl_Type.cxx	(working copy)
@@ -267,9 +267,9 @@
 
 void *Widget_Browser::item_first() const {return Fl_Type::first;}
 
-void *Widget_Browser::item_next(void *l) const {return ((Fl_Type*)l)->next;}
+void *Widget_Browser::item_next(void *l) const {return l ? ((Fl_Type*)l)->next : item_first();}
 
-void *Widget_Browser::item_prev(void *l) const {return ((Fl_Type*)l)->prev;}
+void *Widget_Browser::item_prev(void *l) const {return l ? ((Fl_Type*)l)->prev : item_last();}
 
 int Widget_Browser::item_selected(void *l) const {return ((Fl_Type*)l)->new_selected;}
 
Index: fluid/function_panel.cxx
===================================================================
--- fluid/function_panel.cxx	(revision 13010)
+++ fluid/function_panel.cxx	(working copy)
@@ -500,7 +500,7 @@
       data_filename->align(Fl_Align(133));
       data_filename->when(FL_WHEN_NEVER);
     } // Fl_Input* data_filename
-    { data_filebrowser = new Fl_Button(290, 90, 40, 20, "@fileopen");
+    { data_filebrowser = new Fl_Button(290, 90, 40, 20, FL_SYM_FILEOPEN_TX);
       data_filebrowser->labelcolor((Fl_Color)134);
     } // Fl_Button* data_filebrowser
     { data_comment_input = new Fl_Text_Editor(10, 130, 320, 65, "Comment:");
